Модули node_modules за пределами каталога проекта не передаются Babel (7)

Я пишу приложение, основанное на Symfony4 и ReactJS и использую пакет webpack для сборки пакета. Кроме того, каталог node_modules находится за пределами проекта и является символической ссылкой - возможно, это основной виновник, но мне нужно держать node_modules вне каталога проекта.

Проблема, с которой я столкнулся, связана с использованием некоторых пакетов npm (например, @foes/react-i18n-routing ), которые состоят из компонентов React / HOC, поэтому их нужно переносить, но в итоге я этого не делаю, и в результате я получить ошибку, похожую на эту:

error  in ./node_modules/@foes/react-i18n-routing/dist/esm/component/withI18nRouting.js

Module parse failed: Unexpected token (6:2)
You may need an appropriate loader to handle this file type.
|
| export default Component => props => (
>   <I18nRoutingContext.Consumer>{context => <Component i18nRouting={context} {...props} />}</I18nRoutingContext.Consumer>
| );

Насколько я знаю, когда я использую Babel 7 мне нужно изменить файл .babelrc на babel.config.js чтобы обеспечить широкую конфигурацию проекта, но этого недостаточно, но я все еще сталкиваюсь с проблемой.

Кто-нибудь может указать мне правильное направление?

Я попробовал различные конфиги и остановился на настройке babelrcRoots . Может быть, это ключ, но я не смог установить это правильно.

Вот структура каталогов:

ROOT/
├── node_modules/
└── project/
    ├── assets/
    ├── package.json
    ├── babel.config.js
    └── webpack.config.js

Вот babel.config.js

module.exports = function(api) {
  api.cache(true);

  const presets = ['@babel/preset-env', '@babel/preset-react'];
  const plugins = [
    '@babel/plugin-proposal-class-properties',
    'transform-es2015-modules-commonjs',
    'babel-plugin-dynamic-import-node'
  ];

  // const babelrcRoots = ['.', '../node_modules/*']; ????

  return {
    presets,
    plugins
  };
};


А вот и webpack.config.js

const Encore = require('@symfony/webpack-encore');
const path = require('path');

Encore
  .setOutputPath('public/build/')
  .setPublicPath('/build')
  .addEntry('app', './assets/js/app.jsx')
  .splitEntryChunks()
  .enableSingleRuntimeChunk()
  .cleanupOutputBeforeBuild()
  .enableBuildNotifications()
  .enableSourceMaps(!Encore.isProduction())
  .enableVersioning(Encore.isProduction())
  .enableLessLoader()
  .enableReactPreset();


let config = Encore.getWebpackConfig();
config.resolve.alias['App'] = path.resolve(__dirname, 'assets/js');
// config.resolve.modules = [path.resolve('./node_modules'), path.resolve('../node_modules')]; here's the another try with no luck

module.exports = config;

И вот package.json

{
  "devDependencies": {
    "@babel/preset-react": "^7.0.0",
    "@symfony/webpack-encore": "^0.27.0",
    "babel-plugin-dynamic-import-node": "^2.2.0",
    "babel-polyfill": "^6.26.0",
    "babel-preset-env": "^1.7.0",
    "babel-preset-react": "^6.24.1",
    "core-js": "^3.0.0",
    "less-loader": "^4.1.0",
    "prop-types": "^15.7.2",
    "webpack-notifier": "^1.6.0"
  },
  "dependencies": {
    "@babel/plugin-proposal-class-properties": "^7.4.4",
    "@foes/react-i18n-routing": "^0.8.0",
    "enzyme": "^3.9.0",
    "enzyme-adapter-react-16": "^1.12.1",
    "history": "^4.9.0",
    "lodash.flatmap": "^4.5.0",
    "react": "^16.8.6",
    "react-dom": "^16.8.6",
    "react-router-dom": "^5.0.0",
    "react-router-named-routes": "0.0.23"
  }
}


Всего 1 ответ


Вы можете попробовать настроить на rootMode:"upward" упомянутый здесь, вот так:

babel --root-mode upward src -d lib

или в веб-пакете

module: {
        rules: [{
            loader: "babel-loader",
            options: {
                rootMode: "upward",
            }
        }]
    }

Есть идеи?

10000